﻿local L = LibStub("AceLocale-3.0"):GetLocale("ExPack");
local ExPack = ExPack;

--[[
	Using AceConfig-3.0
	Creating an options table and handlers
	Changes - v0.2.0
		Enabled = true,
		ShowAll = true,
		ShowReagent = true,
		ErrorReporting = true,
		DebugTracing = false,
	Changes - v0.2.1
		ShowBanks = true,
	Changes - v0.2.3 - REJECTED
		RightAlignment = false,
		RightAlignment = {
			type = "toggle",
			name = "Text right alignment",
			desc = "Align the text to the right",
			width = "full",
			get = function(info) return ExPack.db.profile.RightAlignment; end,
			set = function(info, v) ExPack.db.profile.RightAlignment = v; end,
			order = 2
		},
	Changes - v0.2.4
		ShowBorder = false
	Changes - v0.2.5
		(no changes)
	Changes - v0.3.0
		(no changes)
	Changes - v0.3.1
		UseLibItemInfo = false,
	Changes - v0.3.2
		ShowConsumable = true,
		ShowTradegoods = true,
		ShowJunk = true,
		ShowQuestitem = true,
]]--

ExPack.options = {
	name = L["ExPack by |cFF66ccffGhordian |rOptions"],
	type = 'group',
	args = {	
		Enabled = {
			type = "toggle",
			name = L["Enable ExPack"],
			desc = L["Enables/Disables ExPack."],
			width = "full",
			get = function(info) return ExPack.db.profile.Enabled; end,
			set = function(info, v) ExPack.db.profile.Enabled = v; end,
			order = 1,
		},
		Section1 = {
			type = "header",
			name = L["Filters"],
			order = 2,
		},
		ShowAll = {
			type = "toggle",
			name = L["ShowAll"],
			desc = "Displays which expansion any item is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowAll; end,
			set = function(info, v) ExPack.db.profile.ShowAll = v 
					--[[or not ExPack.db.profile.ShowReagents
					or not ExPack.db.profile.ShowConsumable
					or not ExPack.db.profile.ShowTradegoods
					or not ExPack.db.profile.ShowJunk
					or not ExPack.db.profile.ShowQuestitem
					]]--
				end,
			order = 3,
		},
		ShowReagents = {
			type = "toggle",
			name = L["ShowReagents"],
			desc = "Displays which expansion reagents is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowReagents; end,
			set = function(info, v) ExPack.db.profile.ShowReagents = v 
					--or not ExPack.db.profile.ShowAll; 
				end,
			disabled = function(info) return ExPack.db.profile.ShowAll; end,
			order = 31,
		},
		ShowConsumable = {
			type = "toggle",
			name = L["ShowConsumable"],
			desc = "Displays which expansion reagents is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowConsumable; end,
			set = function(info, v) ExPack.db.profile.ShowConsumable = v 
					--or not ExPack.db.profile.ShowAll; 
				end,
			disabled = function(info) return ExPack.db.profile.ShowAll; end,
			order = 32,
		},
		ShowTradegoods = {
			type = "toggle",
			name = L["ShowTradegoods"],
			desc = "Displays which expansion reagents is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowTradegoods; end,
			set = function(info, v) ExPack.db.profile.ShowTradegoods = v 
					--or not ExPack.db.profile.ShowAll; 
				end,
			disabled = function(info) return ExPack.db.profile.ShowAll; end,
			order = 33,
		},
		ShowJunk = {
			type = "toggle",
			name = L["ShowJunk"],
			desc = "Displays which expansion reagents is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowJunk; end,
			set = function(info, v) ExPack.db.profile.ShowJunk = v 
					--or not ExPack.db.profile.ShowAll; 
				end,
			disabled = function(info) return ExPack.db.profile.ShowAll; end,
			order = 34,
		},
		ShowQuestitem = {
			type = "toggle",
			name = L["ShowQuestitem"],
			desc = "Displays which expansion reagents is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowQuestitem; end,
			set = function(info, v) ExPack.db.profile.ShowQuestitem = v 
					--or not ExPack.db.profile.ShowAll; 
				end,
			disabled = function(info) return ExPack.db.profile.ShowAll; end,
			order = 35,
		},
		ShowArmory  = {
			type = "toggle",
			name = L["ShowArmory"],
			desc = "Displays which expansion reagents is from",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowArmory; end,
			set = function(info, v) ExPack.db.profile.ShowArmory = v 
					--or not ExPack.db.profile.ShowAll; 
				end,
			disabled = function(info) return ExPack.db.profile.ShowAll; end,
			order = 36,
		},
		ShowBanks = {
			type = "toggle",
			name = L["Enable Banks Only"],
			desc = "Displays which expansion item is from for any bank's slot",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowBanks; end,
			set = function(info, v) ExPack.db.profile.ShowBanks = v; end,
			order = 50
		},
		UseLibItemInfo = {
			type = "toggle",
			name = L["UseLibItemInfo"],
			desc = "Use UseLibItemInfo when ItemId is not found in current database",
			width = "full",
			get = function(info) return ExPack.db.profile.UseLibItemInfo; end,
			set = function(info, v) ExPack.db.profile.UseLibItemInfo = v; end,
			order = 60
		},
		Section2 = {
			type = "header",
			name = L["Reports"],
			order = 100,
		},
		ErrorReporting = {
			type = "toggle",
			name = L["Report errors to chat window"],
			desc = "Report errors to chat window",
			width = "full",
			get = function(info) return ExPack.db.profile.ErrorReporting; end,
			set = function(info, v) ExPack.db.profile.ErrorReporting = v; end,
			order = 110
		},
		DebugTracing = {
			type = "toggle",
			name = L["Report debug tracing to chat window"],
			desc = "Report debug tracing to chat window",
			width = "full",
			get = function(info) return ExPack.db.profile.DebugTracing; end,
			set = function(info, v) ExPack.db.profile.DebugTracing = v; end,
			order = 120
		},
		ResetExPack = {
			type = "execute",
			name = L["Reset ExPack (Reloads UI after)"],
			desc = "Recommended after addon updates to correct missing profile settings.",
			width = "double",
			func = function()
				ExPackDB = nil;
				ExPackDB = {};
				ExPackDB.profile = ExPack.db.defaults.profile;
				ReloadUI();
			end,
			order = 130,
		},
		VisualSection = {
			type = "header",
			name = "Visual",
			order = 200,
		},
		ShowCaption = {
			type = "toggle",
			name = L["Show Item Caption"],
			desc = "Displays colored caption",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowCaption; end,
			set = function(info, v) ExPack.db.profile.ShowCaption = v or not ExPack.db.profile.ShowBorder; end,
			order = 210
		},
		ShowBorder = {
			type = "toggle",
			name = L["Show Item Border"],
			desc = "Displays colored outline border",
			width = "full",
			get = function(info) return ExPack.db.profile.ShowBorder; end,
			set = function(info, v) ExPack.db.profile.ShowBorder = v or not ExPack.db.profile.ShowCaption; end,
			order = 220
		},
		IconRecommend = {
			type = "description",
			name =  ExPack.majorToExpac[1].color.. " " .. ExPack.majorToExpac[1].shortName .. "|r - " ..ExPack.majorToExpac[1].canonName.."\r\n"..
					ExPack.majorToExpac[2].color.. " " .. ExPack.majorToExpac[2].shortName .. "|r - " ..ExPack.majorToExpac[2].canonName.."\r\n"..
					ExPack.majorToExpac[3].color.. " " .. ExPack.majorToExpac[3].shortName .. "|r - " ..ExPack.majorToExpac[3].canonName.."\r\n"..
					ExPack.majorToExpac[4].color.. " " .. ExPack.majorToExpac[4].shortName .. "|r - " ..ExPack.majorToExpac[4].canonName.."\r\n"..
					ExPack.majorToExpac[5].color.. " " .. ExPack.majorToExpac[5].shortName .. "|r - " ..ExPack.majorToExpac[5].canonName.."\r\n"..
					ExPack.majorToExpac[6].color.. " " .. ExPack.majorToExpac[6].shortName .. "|r - " ..ExPack.majorToExpac[6].canonName.."\r\n"..
					ExPack.majorToExpac[7].color.. " " .. ExPack.majorToExpac[7].shortName .. "|r - " ..ExPack.majorToExpac[7].canonName.."\r\n"..
					ExPack.majorToExpac[8].color.. " " .. ExPack.majorToExpac[8].shortName .. "|r - " ..ExPack.majorToExpac[8].canonName.."\r\n"..
					ExPack.majorToExpac[9].color.. " " .. ExPack.majorToExpac[9].shortName .. "|r - " ..ExPack.majorToExpac[9].canonName.."\r\n"..
					ExPack.majorToExpac[10].color.." " .. ExPack.majorToExpac[10].shortName.. "|r - " ..ExPack.majorToExpac[10].canonName.."\r\n",
			width = "full",
			fontSize = "medium",
			order = 230,
		},
		Section3 = {
			type = "header",
			name = L["Commands"],
			order = 300,
		},
		CMDs = {
			type = "description",
			name = L["/ep : Brings up this window."],
			fontSize = "medium",
			order = 310,
		},
		Section4 = {
			type = "header",
			name = "Synopsis",
			order = 400,
		},
		Synopsis = {
			type = "description",
			name = "Item ExPack Overlay addon.\r\n"..
					"\r\n" .. 
					"This addon will scan any item slot to apply a text overlay on will be shown the abbreviation of the "..
					"expansion pack the item belongs.\r\n\r\n" .. 
					"The text will be colored by the most popular color of the expansion, so it will be easily recognized "..
					"event when the background is dark.\r\n" ..					
					"\r\n" ..
					"TODO's\r\n"..
					" + Add more filter options.\r\n"..
					" + Add more visual options.\r\n"..
					" + Compatibility with many bag's addons like (but not only) Bagnon, AdiBags, OneBag3.\r\n"..
					"\r\n" ..
					"All item information is gathered from Wowhead.\r\n" ..					
					"\r\n"..
					"Thank you all for your feedback and suggestions!",
			fontSize = "medium",
			order = 410,
		},
		Section5 = {
			type = "header",
			name = "Author",
			order = 500,
		},
		About = {
			type = "description",
			name = "Hi, I'm Ghordian from EU-Mazrigos.\r\n\r\n" ..
					"I have been playing WoW since 2009 but never dare to write my own addon until now ;-)\r\n" ..
					"\r\n\r\n" ..
					"CREDITS: I do not own any of the images for the icons.\r\n" ..
					"I do not own the ItemVersion data table.\r\n\r\n"..
					"I want to thank the authors of |cFF66ccffSmexyMats |rand |cFF66ccffItemVersion |rfor the inspiration they have given me.\r\n"..
					"And to my fellow guild members for being the first beta testers.\r\n",
			fontSize = "medium",
			order = 510,
		},
	},
};