local _, AddonTable = ...
local ExPack = ExPack;

local L = LibStub("AceLocale-3.0"):GetLocale("ExPack");
local LII = LibStub("LibItemInfo-1.0");

--https://wowpedia.fandom.com/wiki/API_GetContainerNumSlots
--local GetContainerNumSlots = C_Container.GetContainerNumSlots;
  local function getNumSlots(bagID)
    if C_Container and C_Container.GetContainerNumSlots then
      return C_Container.GetContainerNumSlots(bagID)
    else
      return GetContainerNumSlots(bagID)
    end
  end 
  
--https://wowpedia.fandom.com/wiki/API_GetContainerItemLink
--local GetContainerItemLink = C_Container.GetContainerItemLink;
  local function getItemLink(containerIndex, slotIndex)
    if C_Container and C_Container.GetContainerItemLink then
      return C_Container.GetContainerItemLink(containerIndex, slotIndex)
    else
      return GetContainerItemLink(containerIndex, slotIndex)
    end
  end 
  
  --https://wowpedia.fandom.com/wiki/API_GetContainerItemInfo
  local function getContainerItemInfo(bagID, slot)
    if C_Container and C_Container.GetContainerItemInfo then
		return C_Container.GetContainerItemInfo(bagID, slot)
	elseif GetContainerItemInfo then
	  return GetContainerItemInfo(bagID, slot)
	else
	  return icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID, isBound 
	end
  end

  --https://wowpedia.fandom.com/wiki/API_GetContainerNumFreeSlots
  local function getContainerNumFreeSlots(bagIndex)
    if C_Container and C_Container.GetContainerNumFreeSlots then
	  return C_Container.GetContainerNumFreeSlots(bagIndex)
	elseif GetContainerNumFreeSlots then
	  return GetContainerNumFreeSlots(bagIndex)
	else
	  return numFreeSlots, bagFamily 
	end
  end
  
  --https://wowpedia.fandom.com/wiki/API_GetContainerItemCooldown
  local function getContainerItemCooldown(bagID, slot)
	if C_Container and C_Container.GetContainerItemCooldown then
	  return C_Container.GetContainerItemCooldown(bagID, slot)
	elseif GetContainerItemCooldown then
	  return GetContainerItemCooldown(bagID, slot)
	else
	  return startTime, duration, isEnabled 
	end
  end
  
  function IsConsumable(classID, subclassID)
	if (classID == 15) then -- Miscellaneous
		return (subclassID == 1) -- Reagent
	else
		return (classID == 0) -- Consumable
	end
  end
  function IsArmory(classID, subclassID)
	if (classID == 2) then -- Weapon
		return true
	elseif (classID == 4) then -- Armor
		return true
	else
		return false
	end
  end
  function IsTradegoods(classID, subclassID)
	return (classID == 7) -- Tradegoods
  end
  function IsQuestitem(classID, subclassID)
	return (classID == 12) -- QuestItem
  end
  function IsJunk(classID, subclassID)
	if (classID == 15) then -- Miscellaneous
		return (subclassID == 0) -- Junk
	else
		return false
	end 
  end
  
  function ExPack:IsProfileSelected(classID, subclassID)
	--ExPack:dPrint("IsProfileSelected; "..classID.."; "..subclassID)
	return (self.db.profile.ShowConsumable and IsConsumable(classID, subclassID))
		or (self.db.profile.ShowTradegoods and IsTradegoods(classID, subclassID))
		or (self.db.profile.ShowJunk and IsJunk(classID, subclassID))
		or (self.db.profile.ShowQuestitem and IsQuestitem(classID, subclassID))
		or (self.db.profile.ShowArmory and IsArmory(classID, subclassID));
  end
    
--[[
LoadAddOn("Blizzard_DebugTools")
ddump=DevTools_Dump
]]--
local guildBank = ExPack.guildBank;
local bag_time = 0;
local bagupdatesw = false;

--https://wowpedia.fandom.com/wiki/BagID
ExPack.Types = {
	BAGS		= 1,		-- All bags, 0 to 11, and keyring ( id -2 )
    BANK		= 2,		-- 28 main slots
	GUILDBANK	= 3,		-- 98 main slots
	REAGENTS	= 4,		-- 98 main slots
}

ExPack.Colors = {
	CLASSIC		= "|cFFE6CC80",
	TBC			= "|cFF1EFF00",
	WOTLK		= "|cFF66ccff",
	CATA		= "|cFFff3300",
	MOP			= "|cFF00FF96",
	WOD			= "|cFFff8C1A",
	LEGION		= "|cFFA335EE",
	BFA 		= "|cFFFF7D0A",
	SHADOWLANDS = "|cFFC0C0C0",
	DRAGONFLIGHT= "|cFFFFCC00",

	yellow 		= "|cFFFFFF00",
	white 		= "|cFFFFFFFF",

	common 		= "|cFFFFFFFF",
	uncommon 	= "|cFF1EFF00",
	rare 		= "|cFF0070DD",
	epic 		= "|cFFA335EE",
	legendary 	= "|cFFFF8000",
	artifact 	= "|cFFE6CC80",
	wowtoken	= "|cFF00CCFF",

	DeathKnight = "|cFFC41F3B",
	DemonHunter = "|cFFA330C9",
	Druid 		= "|cFFFF7D0A",
	Hunter 		= "|cFFABD473",
	Mage 		= "|cFF69CCF0",
	Monk 		= "|cFF00FF96",
	Paladin 	= "|cFFF58CBA",
	Priest 		= "|cFFFFFFFF",
	Rogue 		= "|cFFFFF569",
	Shaman 		= "|cFF0070DE",
	Warlock 	= "|cFF9482C9",
	Warrior 	= "|cFFC79C6E",
};

ContainerTypes = {
	[ExPack.Types.BAGS] = {
		GetType = function(self)
				return ExPack.Types.BAGS
			end,
		GetSize = function(self, bagID)
				return getNumSlots(bagID)
			end,
		GetFreeSlots = function(self, bagID)
				-- https://wowpedia.fandom.com/wiki/API_GetContainerNumFreeSlots
				local freeSlots, bagType = getContainerNumFreeSlots(bagID)
				-- https://wowpedia.fandom.com/wiki/ItemFamily
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID, bagID)
				-- https://wowpedia.fandom.com/wiki/API_GetContainerItemLink
				return getItemLink(bagID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				--return _G["ContainerFrame"..bagID.."Item"..slotID]
				local frameIndex = (getNumSlots(bagID) + 1) - slotID;
				if (container == 0 and not IsAccountSecured()) then
					frameIndex = frameIndex + 4;
				end
				frame = _G["ContainerFrame"..(bagID+1).."Item"..frameIndex]
			end,
		GetCount = function(self, slotID, bagID)
				local _, count = getContainerItemInfo(bagID, slotID)
				return count
			end,
		GetCooldown = function(self, slotID, bagID)
				local startTime, duration, isEnabled = getContainerItemCooldown(bagID, slotID)
				return startTime, duration, isEnabled
			end,
	},
	[ExPack.Types.BANK] = {
		GetType = function(self)
				return ExPack.Types.BANK
			end,
		GetSize = function(self)
				return NUM_BANKGENERIC_SLOTS or 28		-- hardcoded in case the constant is not set
			end,
		GetFreeSlots = function(self)
				local freeSlots, bagType = getContainerNumFreeSlots(-1)		-- -1 = player bank
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID)				
				return getItemLink(-1, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				if (slotID and bagID) then
					--ExPack:dPrint("GetFrame; "..bagID.."; "..slotID)
				end
				return _G["ContainerFrame"..bagID.."Item"..slotID]
			end,
		GetCount = function(self, slotID)				
				return select(2, getContainerItemInfo(BANK_CONTAINER, slotID))
			end,
		GetCooldown = function(self, slotID)
				local startTime, duration, isEnabled = GetInventoryItemCooldown("player", slotID)
				return startTime, duration, isEnabled
			end,
	},
	[ExPack.Types.GUILDBANK] = {
		GetType = function(self)
				return ExPack.Types.GUILDBANK
			end,
		GetSize = function(self)
				return MAX_GUILDBANK_SLOTS_PER_TAB or 98		-- hardcoded in case the constant is not set
			end,
		GetFreeSlots = function(self)
				return nil, nil
			end,
		GetLink = function(self, slotID, tabID)
				if (slotID and bagID) then
					--ExPack:dPrint("GuildBank; GetLink; "..slotID.."; "..tabID)
				end
				return GetGuildBankItemLink(tabID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				local NumSlotsPerGuildBankGroup = 14; --NUM_SLOTS_PER_GUILDBANK_GROUP
				local index = mod(slotID, NumSlotsPerGuildBankGroup);
				if ( index == 0 ) then
					index = NumSlotsPerGuildBankGroup;
				end
				local column = ceil((slotID-0.5) / NumSlotsPerGuildBankGroup);
			    local button = _G["GuildBankColumn"..column.."Button"..index];
				if button == nil then
					-- 9.x.x
					button = GuildBankframe.Columns[column].Buttons[index];
				end
				return button;
			end,
		GetCount = function(self, slotID, tabID)
				local _, count = getContainerItemInfo(tabID, slotID)
				return count
			end,
		GetCooldown = function(self, slotID)
				return nil
			end,
	},
	[ExPack.Types.REAGENTS] = {
		GetType = function(self)
				return ExPack.Types.REAGENTS
			end,
		GetSize = function(self)
				return MAX_GUILDBANK_SLOTS_PER_TAB or 98		-- hardcoded in case the constant is not set
			end,
		GetFreeSlots = function(self)
				local freeSlots, bagType = getContainerNumFreeSlots(REAGENTBANK_CONTAINER)
				return freeSlots, bagType
			end,
		GetLink = function(self, slotID, bagID)
				return getItemLink(bagID, slotID)
			end,
		GetFrame = function(self, slotID, bagID)
				return _G["ReagentBankFrameItem"..(slotID)];
			end,
		GetCount = function(self, slotID, bagID)
				local _, count = getContainerItemInfo(REAGENTBANK_CONTAINER, slotID)
				return count
			end,
		GetCooldown = function(self, slotID)
				return nil
			end,
	},
}

--- *** clean functions ***

function CleanBagFrame(BagID, slotID, bagframe)
	if bagframe then
		if bagframe:GetParent() and bagframe:GetParent():GetID() then
			if bagframe.ExPack then
				bagframe.ExPack:SetTextColor(1,1,1) -- white
				bagframe.ExPack:SetText( "" )
				bagframe.ExPack:Hide()
			end
		end
		ExPack:dReset();
	end
end

function ExPack:ScanBagFrame(BagID, slotID, bagframe, thisContainer)
	if bagframe then
		if bagframe:GetParent() and bagframe:GetParent():GetID() then
			local containerID = bagframe:GetParent():GetID()
			local slot = bagframe:GetID()
			-- first clean
			CleanBagFrame(BagID, slot, bagframe)
			-- workarround; skip a bank-bag not filled/updated
			if (containerID) and (containerID == 100) then
				--ExPack:jPrint("ScanBagFrame; contanierID; "..containerID);
				return
			end
			if self.db.profile.ShowBanks then 
				local bagType = 0
				if thisContainer then
					bagType = thisContainer.GetType() or 0
				end
				-- skip inventory bags
				ExPack:dPrint("ScanBagFrame; "..BagID.."; "..slotID.."; "..containerID.."; "..bagType)
				if ExPack.Types.BAGS == bagType then
					if (BagID <= NUM_BAG_SLOTS+1) or (containerID <= NUM_BAG_SLOTS+1) then
						-- skip inventory bags
						ExPack:dPrint("ScanBagFrame; "..BagID.."; "..slotID.."; "..containerID.."; "..bagType)
						return
					end
				end
			end
			if not bagframe.ExPack and self.db.profile.ShowCaption then
				-- REJ:GameFontNormalSmall
				-- ORG:NumberFontNormalSmall
				bagframe.ExPack = bagframe:CreateFontString(nil, "OVERLAY", "NumberFontNormalSmall")
				bagframe.ExPack:SetPoint("TOPLEFT", bagframe, 0, -2)	-- ok-DF
				bagframe.ExPack:SetTextColor(1,1,0) -- yellow
				bagframe.ExPack:SetText("")
				if self.db.profile.DebugTracing then
					bagframe.ExPack:SetTextColor(1,1,1) -- white
					--ExPack:jPrint("ScanBagFrame; "..BagID.."; "..slotID);
					expname = containerID..","..slot
					bagframe.ExPack:SetText( expname )
				end	
			end
			if not bagframe.ExPackIcon and self.db.profile.ShowBorder then
			    bagframe.ExPackIcon = bagframe:CreateTexture(nil, "OVERLAY")
				bagframe.ExPackIcon:SetTexture("Interface\\Addons\\Ghordian_ExPack\\images\\ExPack3bIconBorder");
				bagframe.ExPackIcon:SetAllPoints(bagframe)
				bagframe.ExPackIcon:SetBlendMode("BLEND")
				bagframe.ExPackIcon:SetPoint("CENTER", bagframe)
				-- same TextCoord dumped from CosmeticIconFrame
			--	bagframe.ExPackIcon:SetTexCoord(0.0078125, 0.5078125, 0.0078125, 0.5078125) -- org
			end

			if ( BagID and containerID ) then
				--ExPack:jPrint("ScanBagFrame; containerID; "..BagID.." <> "..containerID);
			end
			if ( slotID ~= slot ) then
				--ExPack:jPrint("ScanBagFrame; slotID; "..slotID.." <> "..slot);
			end

			local itemLink = nil
			if thisContainer then
				if (containerID) then
					if (containerID ~= BagID) then
						--ExPack:jPrint("thisContainer; containerID; "..BagID.." <> "..containerID.."; slotID; "..slotID.." <> "..slot)
--[[
	guildBank.isGuildBankOpen = true
	guildBank.tab = GetCurrentGuildBankTab()
]]--
						if guildBank.isGuildBankOpen then
							containerID	= BagID -- needed
						end
					else
						--ExPack:jPrint("thisContainer; containerID; "..BagID.." = "..containerID.."; slotID; "..slotID.." <> "..slot)
					end
				else
					--ExPack:jPrint("thisContainer; non-containerID; "..BagID.."; slotID; "..slotID.." <> "..slot)					
					containerID	= BagID -- debug
				end
			----itemLink = thisContainer:GetLink(slot, BagID)
				itemLink = thisContainer:GetLink(slot, containerID)
			else
				if (containerID) then
					if (containerID ~= BagID) then
						--ExPack:jPrint("non-thisContainer; containerID; "..BagID.." <> "..containerID.."; slotID; "..slotID.." <> "..slot)
					else
						--ExPack:jPrint("non-thisContainer; containerID; "..BagID.." = "..containerID.."; slotID; "..slotID.." <> "..slot)
					end
				else
					--ExPack:jPrint("non-thisContainer; non-containerID; "..BagID.."; slotID; "..slotID.." <> "..slot)
					--containerID = BagID -- debug
					--slot = slotID --debug
				end
				itemLink = getItemLink(containerID, slot)
			end
			if itemLink then
				-- https://wowpedia.fandom.com/wiki/API_GetItemInfo
				-- itemName, itemLink, itemQuality, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, sellPrice, classID, subclassID, bindType, expacID, setID, isCraftingReagent = GetItemInfo(item) 
				--       1, 2,       3,         4, 5,        6,           7,  8, 9,10,        11,      12, 		   13, 14,      15, 16,                17
				local name, _, quality, itemLevel, _, itemType, itemSubType, _, _,  _, sellPrice, classID, subclassID,  _, expacID,  _, isCraftingReagent = GetItemInfo(itemLink)
				-- mfm
				local expname = "n/a";
				local clr = "|cFFffff00";
				--local itemExpac
				local itemID = ExPack:GetIDFromLink(itemLink);
				--(expacID ~= nil) and 
				if (expacID) and (expacID > 0) then
					-- expacID
					expacID = expacID + 1;
					local itemExpac = ExPack:getMajorFromExpacID(expacID);
					if itemExpac ~= nil then
						expname = itemExpac.shortName;
						clr = itemExpac.color;
						--itemID = -itemID; no seguir buscando
else
-- seguir buscando
						expacID = 0;
					end
					--ExPack:dPrint("GetItemInfo; "..expacID.." ; "..expname)
				else
					expacID = 0;
					quality = quality or -1;
					--ExPack:dPrint("No expacID; itemID; "..itemID.." ; quality; "..quality)
				end
				
				if (itemID > 0) and (expacID == 0) then
					local itemVersion = ExPack:myGetVersion(itemID);
					if itemVersion then
						--ExPack:vardump (itemVersion);
						local itemExpac = ExPack:myGetVersionExpac(itemVersion);
						if itemExpac ~= nil then
							expname = itemExpac.shortName;
							clr = itemExpac.color;
						else
							ExPack:dPrint("itemExpac nil; "..itemID.." ; "..quality)
						end
					else
						ExPack:dPrint("itemVersion nil; "..itemID.." ; "..quality)
					end
				else
					--itemID = -itemID;
				end
--
				local ShowExPack = (self.db.profile.ShowAll 
					or (self.db.profile.ShowReagents and (isCraftingReagent or false)))
					or ExPack:IsProfileSelected(classID, subclassID);
				local Color = {}
				local r,g,b
				r, g, b = clr:match("|cFF(%x%x)(%x%x)(%x%x)")
				r, g, b = tonumber(r, 16), tonumber(g, 16), tonumber(b, 16)
				Color.r, Color.g, Color.b = r / 255, g / 255, b / 255						
				if bagframe.ExPack then					
					if self.db.profile.Enabled then
						if (itemID > 0) and ShowExPack and self.db.profile.ShowCaption then
							bagframe.ExPack:SetTextColor(Color.r, Color.g, Color.b);
							bagframe.ExPack:SetText( expname );
							bagframe.ExPack:Show();
						else
							bagframe.ExPack:SetText( "" )
						end
					else
						bagframe.ExPack:SetText( "" )
					end
				end				
				if bagframe.ExPackIcon then
					if self.db.profile.Enabled then
						if (itemID > 0) and ShowExPack and self.db.profile.ShowBorder then
							bagframe.ExPackIcon:SetVertexColor(Color.r, Color.g, Color.b, 1)
							bagframe.ExPackIcon:SetTexCoord(0.01, 0.50, 0.01, 0.50)	--ok						
							bagframe.ExPackIcon:Show();
						else
							bagframe.ExPackIcon:Hide();
						end
					else
						bagframe.ExPackIcon:Hide();
					end;
				end
			else
				if bagframe.ExPack then
					expname = ""
					bagframe.ExPack:SetTextColor(1,1,1) -- white
					if self.db.profile.DebugTracing 
						--and self.db.profile.ShowAll 
						then
					  expname = containerID..","..slot
					end
					bagframe.ExPack:SetText( expname )
				end
				if bagframe.ExPackIcon then
					bagframe.ExPackIcon:Hide();
				end
			end
		else
			if bagframe.ExPack then
				bagframe.ExPack:SetTextColor(1,1,1) -- white
				bagframe.ExPack:SetText( "" )
			end
			if bagframe.ExPackIcon then
				bagframe.ExPackIcon:Hide();
			end
		end
	else
		ExPack:jPrint("No bagframe; "..BagID..";"..slotID)
		--ExPack:dPrint("No bagframe; "..BagID..";"..slotID)
	end
end

local printcount = 0

function ExPack:vardump (t)
	ExPack:dReset();
	if (type (t) ~= "table") then
		return
	end
	if ( printcount > 0 ) then
		for a,b in pairs (t) do 
			ExPack:dPrint (a,b)
		end
		printcount = printcount -1
	end
end

function ExPack:dPrint(...)
	if self.db.profile.DebugTracing then
		ExPack:Print(...)
	end
end

function ExPack:jPrint(...)
	if ( printcount > 0 ) then
		ExPack:dPrint(...)
		printcount = printcount -1
	end
end

function ExPack:dReset(...)
	printcount = 15
end

-- *** ItemVersion Data API ***

function ExPack:GetIDFromLink(link)
	if link then
		local id = link:match("item:(%d+):");
		if id then 
			return tonumber(id); 
		elseif link:find("\124Hbattlepet:") then -- caged battle pets all share a single itemid
			return 82800;
		else 
			return 0; 
		end;
	else
		return -1; 
	end;
end

function ExPack:myGetVersion(itemId)
	-- caller must ensure that itemId is a number (188655;169701)
	local itemVersion = nil;
	local itemExpac = nil;
	
	-- 1st priority using the new library, only works for reagents or so :(
	if self.db.profile.UseLibItemInfo then 	
		--ExPack:dPrint("ExPack:myGetVersion; UseLibItemInfo; "..itemId)
		-- try to find expacID using LibItemInfo
		local itemType, expansion, expansionID, arg1, arg2, arg3 = LII:GetItemSource(itemId)
		if itemType and expansion then
			expansionID = expansionID + 1;
			--ExPack:dPrint("ExPack:myGetVersion; expansionID; "..expansionID)
			itemExpac = ExPack:getMajorFromExpacID(expansionID);
			--ExPack:vardump(itemExpac);
		else
			--ExPack:dPrint("LII:GetItemSource; no expansionID; ")
		end
	end
	
	if (itemVersion == nil) then
		--ExPack:dPrint("ExPack:myGetVersion; itemIdToVersionId; "..itemId)
		local versionId = ExPack.itemIdToVersionId[itemId];
		if (versionId == nil) then
			--ExPack:dPrint("ExPack:myGetVersion; not direct found itemId; "..itemId)
			versionId = ExPack:getItemVersion(itemId);
		end
		-- item id found in current database
		if versionId then
			--ExPack:dPrint("ExPack:myGetVersion; direct found versionId; "..versionId)
			itemVersion = ExPack.versionIdToVersion[versionId];
		else
			--ExPack:dPrint("ExPack:myGetVersion; versionId nil; "..itemId)
		end
	end
	
	return itemVersion, itemExpac;
end

function ExPack:GuildBankFrame_RemoveExPack()
	--ExPack:dPrint("GuildBankFrame_RemoveExPack")
	local thisContainer = ContainerTypes[ExPack.Types.GUILDBANK];
	local size = thisContainer:GetSize();
	local tab = GetCurrentGuildBankTab();
	local group = 14; --NUM_SLOTS_PER_GUILDBANK_GROUP;
	local index, column, button;
	for i=1, size do
		index = mod(i, group);
		if ( index == 0 ) then
			index = group;
		end
		column = ceil((i-0.5) / group);
		button = _G["GuildBankColumn"..column.."Button"..index];
		if button == nil then
			--ExPack:dPrint("GuildBankColumn fail")
			button = GuildBankFrame.Columns[column].Buttons[index];
		end
		if button then
			CleanBagFrame(tab, i, button);
		end
	end
end

function ExPack:BankFrame_RemoveExPack()
	ExPack:dPrint("BankFrame_RemoveExPack")
	local thisContainer = ContainerTypes[ExPack.Types.BANK]
	local bagID = BANK_CONTAINER
	local size = thisContainer:GetSize(bagID)
	for slotID=1, size, 1 do
		button = thisContainer:GetFrame(slotID, bagID)
		if button then
			CleanBagFrame(bagID, slotID, button)
		end
	end
end

---

function ExPack:ScanContainer(BagID, containerType)
	if not self.db.profile.Enabled then return end

	if self.db.profile.ShowBanks then 
		if (containerType == ExPack.Types.BAGS) then
			if (BagID <= NUM_BAG_SLOTS+1) then
				-- skip inventory bags
				ExPack:jPrint("ScanContainer; "..containerType.."; "..BagID)
				return
			end
		end
	end
	if (BagID) then
		--ExPack:dPrint("ScanContainer; "..containerType.."; "..BagID)
	end

	local thisContainer = ContainerTypes[containerType]
	
	local bag = {}
	bag.size = thisContainer:GetSize(BagID)
	bag.freeslots, bag.bagtype = thisContainer:GetFreeSlots(BagID)
	bag.container = 0; --isOpen = 0;
	if IsBagOpen(BagID) then
		bag.container = (BagID+1);
	end;

	if (BagID) then
		ExPack:dPrint("ScanContainer; "..containerType.."; "..BagID.."; bag; "..bag.size.."; "..bag.freeslots.."; "..bag.container)
		--ExPack:dPrint("ScanContainer; ".."bag; "..bag.size.."; "..bag.freeslots.."; "..bag.container)
			--.."; "..bag.bagtype)
		ExPack:dReset()
	end
	
	for slotID=1,bag.size do
		-- TutorialHelper:GetItemContainerFrame
		-- ContainerIDToInventoryID ?
		local frame = nil
		if (containerType == ExPack.Types.BAGS) then
			local frameIndex = (getNumSlots(BagID) + 1) - slotID;
			if (container == 0 and not IsAccountSecured()) then
				frameIndex = frameIndex + 4;
			end
			frame = _G["ContainerFrame"..bag.container.."Item"..frameIndex]
		--  frame = thisContainer:GetFrame(BagID, slotID)
		else
			frame = thisContainer:GetFrame(slotID, BagID)
		end
		ExPack:ScanBagFrame(BagID, slotID, frame, thisContainer)	
	end
end

function ExPack:ScanBag(bagID)
	if not self.db.profile.Enabled then return end
	if (bagID < 0) then return end

	ExPack:dPrint("ScanBag; "..bagID)
	ExPack:dReset()

	ExPack:ScanContainer(bagID, ExPack.Types.BAGS)
end

function ExPack:ExPack_ScanBag(bagID)
	if not self.db.profile.Enabled then return end
	--
	ExPack:dPrint("ExPack_ScanBag;"..bagID)

	ExPack:ScanBag(bagID)
end

function ExPack:ExPack_ScanBags(event)
	if not self.db.profile.Enabled then return end
	--
	local msg = "ExPack_ScanBags"
	if event then
		msg = msg.."; "..event
	end
	ExPack:dPrint(msg)
	if ( GetTime() - bag_time > 0.3 ) then
		if not bagupdatesw then
			bagupdatesw = true;
			ExPack:RegisterEvent("BAG_UPDATE")
		end
		local thisContainer = ContainerTypes[ExPack.Types.BAGS]
		-- https://wowpedia.fandom.com/wiki/BagID
		for bagID=0,NUM_CONTAINER_FRAMES do
			ExPack:ScanBag(bagID, thisContainer)
		end
	end
	bag_time = GetTime()
end

--[[
function ExPack:ExPack_OpenAllBags(...)
	if not self.db.profile.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_OpenAllBags
	ExPack:ExPack_ScanBags("OpenAllBags")
end

function ExPack:ExPack_ToggleAllBags(...)
	if not self.db.profile.Enabled then return end
	--
	ExPack:ExPack_ScanBags("ToggleAllBags")
end

function ExPack:ExPack_ToggleBag(bagNum)
	if not self.db.profile.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_ToggleBag
	ExPack:ExPack_ScanBag(bagNum)
end

function ExPack:ExPack_OpenBag(id)
	if not self.db.profile.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_OpenBag
	ExPack:ExPack_ScanBag(id)
end
]]--

function ExPack:ExPack_PickupContainerItem(...)
	if not self.db.profile.Enabled then return end
	-- https://wowpedia.fandom.com/wiki/API_PickupContainerItem
	local bagID, slot = ...; 
	ExPack:dPrint("PickupContainerItem;"..bagID.."; "..slot)
	ExPack:ExPack_ScanBags("PickupContainerItem;"..bagID.."; "..slot) 
end

--	

function ExPack:ExPack_BankFrameItemButton_Update(button)
	if not self.db.profile.Enabled then return end
	if not button.isBag then
		if button:GetParent() and button:GetParent():GetID() then
			local buttonID = button:GetID();
			--ExPack:dPrint("BankFrameItemButton_Update; "..buttonID)

			ExPack:ExPack_ScanThisBag(button, ExPack.Types.BANK)
		end
	end
end

---

function ExPack:ExPack_BagsUpdate(event)
	if not self.db.profile.Enabled then return end
	ExPack:dPrint("ExPack_BagsUpdate; "..event)

	if bag_time == 0 then 
		ExPack_ScanBags() 
	end
	if GetTime() - bag_time > 0.3 then
		ExPack:ExPack_ScanBags(event)
	end
	bag_time = GetTime()
end

function ExPack:ScanBag(bagID)
	if not self.db.profile.Enabled then return end
	if bagID < 0 then return end

	ExPack:dPrint("ScanBag; "..bagID)
	ExPack:dReset();

	ExPack:ScanContainer(bagID, ExPack.Types.BAGS)
end

function ExPack:ScanReagentBank()
	if not self.db.profile.Enabled then return end
	ExPack:dPrint("ScanReagentBank")
	ExPack:dReset();
	
	ExPack:ScanContainer(REAGENTBANK_CONTAINER, ExPack.Types.REAGENTS)
end

function ExPack:ExPack_ScanThisBag(button, containerType)
	if not self.db.profile.Enabled then return end
	if button then
		local id = button:GetID()
		--ExPack:dPrint("ExPack_ScanThisBag; "..id.."; "..containerType)

		local thisContainer = nil 
		-- BankFrame:BankFrameItemButton_Update
		local container = button:GetParent():GetID();
		local buttonID = button:GetID();
		local inventoryID = button:GetInventorySlot();
		if ( button.isBag ) then
		-- we dont want to see where the actually bag(s) comes from ;-)
		else
			ExPack:ScanBagFrame(container, inventoryID, button, thisContainer)
		end
	end
end

function ExPack:ExPack_BagnonFrameinventory()
	if not self.db.profile.Enabled then return end
	ExPack:dPrint("ExPack_BagnonFrameinventory")
end

function ExPack:getMajorFromExpacID(expacID)
	if (AddonTable ~= nil) then
		--ExPack:dPrint("ExPack:getMajorFromExpacID; AddonTable; "..expacID);
		return AddonTable.majorToExpac[expacID]
	elseif (ExPack.majorToExpac ~= nil) then
		--ExPack:dPrint("ExPack:getMajorFromExpacID; majorToExpac; "..expacID);
		return ExPack.majorToExpac[expacID]
	else
		--ExPack:dPrint("ExPack:getMajorFromExpacID; Self; "..expacID);
		return self.majorToExpac[expacID]
	end
end

function ExPack:myGetVersionExpac(version)
	if (AddonTable ~= nil) then
		--ExPack:dPrint("ExPack:myGetVersionExpac; AddonTable; "..version.major);
		return AddonTable.majorToExpac[version.major]
	elseif (ExPack.majorToExpac ~= nil) then
		--ExPack:dPrint("ExPack:myGetVersionExpac; ExPack.majorToExpac; "..version.major);
		return ExPack.majorToExpac[version.major]
	else
		--ExPack:dPrint("ExPack:myGetVersionExpac; self.majorToExpac; "..version.major);
		return self.majorToExpac[version.major]
	end
end 

function ExPack_ContainerFrame_Update(container)
	local BagID = container:GetID()
	local slotID = 0
	local name = container:GetName()
	local thisContainer = ContainerTypes[ExPack.Types.BAGS]
	for i = 1, container.size, 1 do
		local frame = _G[name .. "Item" .. i]
		--UpdateContainerButton(button, bag)
		ExPack:ScanBagFrame(BagID, slotID, frame, thisContainer)
	end
end

function ExPack_ContainerFrame_GenerateFrame(frame, size, id)
	ExPack_ContainerFrame_Update(frame)
end

function ExPack_ContainerFrame_Update(frame)
    for i, bagItemButton in frame:EnumerateValidItems() do
        if (bagItemButton) then
			local BagID = bagItemButton:GetBagID();
			local slotID = bagItemButton:GetID();
            local texture, itemCount, locked, quality, readable, _, itemLink, isFiltered, noValue, itemID, isBound
            if (GetContainerItemInfo) then
                texture, itemCount, locked, quality, readable, _, itemLink, isFiltered, noValue, itemID, isBound = GetContainerItemInfo(bagItemButton:GetBagID(), bagItemButton:GetID());
            else
                local info = C_Container.GetContainerItemInfo(bagItemButton:GetBagID(), bagItemButton:GetID())
                itemID = info and info.itemID;
            end
--[[
            local isCurrentExp = ExpansionMats_ids[itemID]
            local isPrevExp = ExpansionMats_Shadowlands_ids[itemID]
            local tframe = ExpansionMats_GetExpansionMatsFrame(bagItemButton, isPrevExp, 0, 0)
            if (itemID and (isCurrentExp or isPrevExp)) then
                tframe:Show()
            else
                tframe:Hide()
            end
]]--			
			local thisContainer = ContainerTypes[ExPack.Types.BAGS]
			ExPack:ScanBagFrame(BagID, slotID, bagItemButton, thisContainer)
        end
    end
end

--[[
-- expose API functions
ExPack.getItemVersion = AddonTable.getItemVersion
ExPack.buildVersionString = AddonTable.buildVersionString
ExPack.majorToExpac = AddonTable.majorToExpac
]]--
ExPack.getVersionExpac = AddonTable.getVersionExpac
